# Method: projects.locations.clusters.nodePools.rollback

- [HTTP request](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#body.aspect)
- [Try it!](https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.clusters.nodePools/rollback#try-it)

Rolls back a previously Aborted or Failed NodePool upgrade. This makes no changes if the last upgrade successfully completed.

### HTTP request

`POST https://container.googleapis.com/v1/{name=projects/*/locations/*/clusters/*/nodePools/*}:rollback`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` The name (project, location, cluster, node pool id) of the node poll to rollback upgrade. Specified in the format `projects/*/locations/*/clusters/*/nodePools/*`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `container.clusters.update` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "projectId": string, "zone": string, "clusterId": string, "nodePoolId": string, "respectPdb": boolean } ``` |

| Fields ||
|---|---|
| `projectId (deprecated)` | `string` Deprecated. The Google Developers Console [project ID or project number](https://cloud.google.com/resource-manager/docs/creating-managing-projects). This field has been deprecated and replaced by the name field. |
| `zone (deprecated)` | `string` Deprecated. The name of the Google Compute Engine [zone](https://cloud.google.com/compute/docs/zones#available) in which the cluster resides. This field has been deprecated and replaced by the name field. |
| `clusterId (deprecated)` | `string` Deprecated. The name of the cluster to rollback. This field has been deprecated and replaced by the name field. |
| `nodePoolId (deprecated)` | `string` Deprecated. The name of the node pool to rollback. This field has been deprecated and replaced by the name field. |
| `respectPdb` | `boolean` Option for rollback to ignore the PodDisruptionBudget. Default value is false. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/kubernetes-engine/docs/reference/rest/v1/projects.locations.operations#Operation`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/container`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).